# `finallycoffee.matrix.synapse_signing_key` module

Module to generate and manage synapse signing keys.

> [!TIP]
> Supports `check mode` and `diff` rendering

## Requirements

- `python >= 3.9`
- (pip) `signed_json >= 1.1.4`


## Usage examples

```yaml
# Generate a key
- finallycoffee.matrix.synapse_signing_key:
    path: "/not/there/yet/signing.key"
    state: present

# Read a key from the filesystem or generate one
- finallycoffee.matrix.synapse_signing_key:
    path: "/maybe/existing/signing/key"
  register: key_result
- debug:
    msg: "Signing key is '{{ key_result.signing_key }}'"

# Delete an existing signing key file
- finallycoffee.matrix.synapse_signing_key:
    path: "/path/to/key/to/delete.key"
    state: absent
```
